# Creates dynamic struct based on arguments

class CleanHash
  CH_STRUCTS ||= {}

  def self.create_struct hash
    raise ArgumentError.new('Not a hash') unless hash.is_a?(Hash)

    name = 'DynStruct_' + hash.keys.join('_')
    CH_STRUCTS[name] ||= ::Struct.new(name, *hash.keys.sort)

    CH_STRUCTS[name].new.tap do |o|
      hash.each do |k, v|
        o.send('%s=' % k, v) unless v.nil?
      end
    end
  end
end